/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.51 from the
 * contents of AT24C32.xs. Do not edit this file, edit AT24C32.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "AT24C32.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include <stdio.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdlib.h>
#include <linux/fs.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <errno.h>
#include <assert.h>
#include <string.h>
#include "eeprom.h"

int write_cycle_time = 0;

static int _writeAddress(int fd, __u8 buf[2]){
	int r = i2c_smbus_write_byte_data(fd, buf[0], buf[1]);
	if(r < 0){
		fprintf(stderr, "Error _writeAddress: %s\n", strerror(errno));
		croak("_writeAddress() failed to write to the i2c bus\n");
    }
	usleep(10);
	return r;
}

static int _writeByte(int fd, __u8 buf[3]){
	int r;
	r = i2c_smbus_write_word_data(fd, buf[0], buf[2] << 8 | buf[1]);
	if(r < 0){
		fprintf(stderr, "Error _writeByte: %s\n", strerror(errno));
		croak("_writeByte() failed to write to the i2c bus\n");
    }
	usleep(10);
	return r;
}

static int _writeBlock(int fd, __u8 eepromAddr, int len, __u8 *data){
	int r;
	r = i2c_smbus_write_block_data(fd, eepromAddr, len, data);
	if(r < 0){
		fprintf(stderr, "Error _writeBlock: %s\n", strerror(errno));
		croak("_writeBlock() failed to write to the i2c bus\n");
    }
	usleep(10);
	return r;
}

int eeprom_init(char *dev_fqn, int addr, int delay){
	int funcs, fd, r;

	fd = open(dev_fqn, O_RDWR);
	if(fd <= 0)
	{
		fprintf(stderr, "Error eeprom_init: %s\n", strerror(errno));
		return -1;
	}

	// set working device
	if( ( r = ioctl(fd, I2C_SLAVE, addr)) < 0)
	{
		fprintf(stderr, "Error opening EEPROM i2c connection: %s\n", strerror(errno));
		return -1;
	}

    write_cycle_time = delay;

	return fd;
}

int eeprom_close(int fd){
	close(fd);
	return 0;
}

int eeprom_read_current_byte(int fd){
	ioctl(fd, BLKFLSBUF); // clear kernel read buffer
	return i2c_smbus_read_byte(fd);
}

int eeprom_read(int fd, int mem_addr){
	int r;
	ioctl(fd, BLKFLSBUF); // clear kernel read buffer

	__u8 buf[2] = { (mem_addr >> 8) & 0x0ff, mem_addr & 0x0ff };

    r = _writeAddress(fd, buf);

    if (r < 0){
		return r;
    }

    return(i2c_smbus_read_byte(fd));
}

int eeprom_write(int fd, int mem_addr, int data){
    __u8 buf[3] = {
        (__u8)(mem_addr >> 8) & 0x00ff,
        (__u8)mem_addr & 0x00ff,
        (__u8)data
    };

    int ret = _writeByte(fd, buf);
    if (ret == 0 && write_cycle_time != 0) {
        usleep(1000 * write_cycle_time);
    }
    return ret;
}

int eeprom_write_block(int fd, int mem_addr, int data){

    __u8 addr_msb = (mem_addr >> 8) & 0x00ff;
    __u8 buf[2] = {
        mem_addr & 0x00ff,
        data
    };

    int ret = _writeByte(fd, buf);

    if (ret == 0 && write_cycle_time != 0) {
        usleep(1000 * write_cycle_time);
    }
    return ret;
}

#line 138 "AT24C32.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 282 "AT24C32.c"

XS_EUPXS(XS_RPi__EEPROM__AT24C32_eeprom_init); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_RPi__EEPROM__AT24C32_eeprom_init)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "dev_fqn, addr, delay");
    {
	char *	dev_fqn = (char *)SvPV_nolen(ST(0))
;
	int	addr = (int)SvIV(ST(1))
;
	int	delay = (int)SvIV(ST(2))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = eeprom_init(dev_fqn, addr, delay);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_RPi__EEPROM__AT24C32_eeprom_close); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_RPi__EEPROM__AT24C32_eeprom_close)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "fd");
    {
	int	fd = (int)SvIV(ST(0))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = eeprom_close(fd);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_RPi__EEPROM__AT24C32_eeprom_read_current_byte); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_RPi__EEPROM__AT24C32_eeprom_read_current_byte)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "fd");
    {
	int	fd = (int)SvIV(ST(0))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = eeprom_read_current_byte(fd);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_RPi__EEPROM__AT24C32_eeprom_read); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_RPi__EEPROM__AT24C32_eeprom_read)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "fd, mem_addr");
    {
	int	fd = (int)SvIV(ST(0))
;
	int	mem_addr = (int)SvIV(ST(1))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = eeprom_read(fd, mem_addr);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_RPi__EEPROM__AT24C32_eeprom_write); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_RPi__EEPROM__AT24C32_eeprom_write)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "fd, mem_addr, data");
    {
	int	fd = (int)SvIV(ST(0))
;
	int	mem_addr = (int)SvIV(ST(1))
;
	int	data = (int)SvIV(ST(2))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = eeprom_write(fd, mem_addr, data);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_RPi__EEPROM__AT24C32_eeprom_write_block); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_RPi__EEPROM__AT24C32_eeprom_write_block)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "fd, mem_addr, data");
    {
	int	fd = (int)SvIV(ST(0))
;
	int	mem_addr = (int)SvIV(ST(1))
;
	int	data = (int)SvIV(ST(2))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = eeprom_write_block(fd, mem_addr, data);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C" {
#endif
XS_EXTERNAL(boot_RPi__EEPROM__AT24C32); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_RPi__EEPROM__AT24C32)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("RPi::EEPROM::AT24C32::eeprom_init", XS_RPi__EEPROM__AT24C32_eeprom_init);
        newXS_deffile("RPi::EEPROM::AT24C32::eeprom_close", XS_RPi__EEPROM__AT24C32_eeprom_close);
        newXS_deffile("RPi::EEPROM::AT24C32::eeprom_read_current_byte", XS_RPi__EEPROM__AT24C32_eeprom_read_current_byte);
        newXS_deffile("RPi::EEPROM::AT24C32::eeprom_read", XS_RPi__EEPROM__AT24C32_eeprom_read);
        newXS_deffile("RPi::EEPROM::AT24C32::eeprom_write", XS_RPi__EEPROM__AT24C32_eeprom_write);
        newXS_deffile("RPi::EEPROM::AT24C32::eeprom_write_block", XS_RPi__EEPROM__AT24C32_eeprom_write_block);
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

#ifdef __cplusplus
}
#endif
